﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

using Vita.Entities;
using Vita.Entities.Model;
using Vita.Entities.Runtime;

namespace Vita.Data {

  /// <summary> An interface representing a persistent data store like SQL database. </summary>
  public interface IDataStore {
    //fired when entity store constructed, but initialization is not complete yet
    void Init(EntityStore entityStore);

    IEnumerable<string> GetSchemas();
    IList<EntityRecord> ExecuteQuery(EntitySession session, IEntityCommand command, Paging paging, object[] args);
    object ExecuteNonQuery(EntitySession session, IEntityCommand command, object[] args);
    void SaveChanges(EntitySession session);
    bool CheckConnectivity();
    
    //LINQ
    object ExecuteDynamicQuery(EntitySession session, EntityQuery query);
  }

}
