﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Vita.Entities.Runtime;

namespace Vita.Entities {
  [Serializable]
  public class ConcurrentUpdateException : NonFatalException {
    public string TableName;
    public string Operation; //Update or Delete
    public string PrimaryKeyValues;
    // TODO: add code that fills in EntityName
    public string EntityName; 


    public ConcurrentUpdateException() { } //for deserialization
    public ConcurrentUpdateException(string message) : this(message, string.Empty, null, null, null) { }
    public ConcurrentUpdateException(string message, string tableName, string operation, string primaryKeyValues, Exception inner)  
                              : base(message, ExceptionStrings.CodeConcurrentUpdateConflict, inner) {
      TableName = tableName;
      Operation = operation;
      PrimaryKeyValues = primaryKeyValues;
    }

  }//class
}
