﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace Vita.Entities {
  /// <summary>Represents a failure to connect to a datastore - database or remote web service.</summary>
  public class ConnectionFailureException : Exception {
    public readonly List<Exception> Exceptions = new List<Exception>();

    public ConnectionFailureException(string message, Exception exception) : base(message) {
      Exceptions.Add(exception);
    }
    public ConnectionFailureException(string message, List<Exception> exceptions) : base(message) {
      Exceptions.AddRange(exceptions);
    }

    public override string ToString() {
      var baseText = base.ToString(); //will include this exc and inner exception's message and stack trace
      var nl = Environment.NewLine;
      if (Exceptions == null) return baseText; 
      var sbExcList = new StringBuilder();
      foreach(var ex in Exceptions) 
        sbExcList.AppendFormat("   Exception: {0}\r\n", ex.Message);
      var result = string.Format("{0}\r\n Internal exceptions: \r\n {1}", baseText, sbExcList.ToString());
      return result; 
    }
  }
}
