﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

using Vita.Entities.Runtime;

namespace Vita.Entities {
  [Serializable]
  public class UniqueIndexViolationException : NonFatalException {
    public string EntityName; 
    public string KeyName;     //Name of EntityKey
    public string DbKeyName;     //Name of DB index
    public string MemberNames; //semicolon-delimited list of member names

    public UniqueIndexViolationException() {} //for deserialization
    public UniqueIndexViolationException(string message) : this(message, string.Empty, null) { }
    public UniqueIndexViolationException(string message, string dbKeyName, Exception inner) : base(message, ExceptionStrings.CodeUniqueIndexViolation, inner) {
      DbKeyName = dbKeyName; 
    }

  }//class
}
