﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vita.Entities;
using Vita.Logging;

namespace Vita.Entities.Runtime {

  public class AppActivationContext {
    public IEntityStore EntityStore; 
    public readonly Log Log;

    public AppActivationContext(IEntityStore entityStore, string logFile = null) {
      EntityStore = entityStore; 
      Log = new Log(outFile: logFile);
    }

    public bool CheckActivationErrors(bool throwIfErrors = true) {
      if (!Log.HasErrors)
        return true;
      var actLog = Log.GetAllAsText();
      if (throwIfErrors)
        throw new ActivationException("Model activation failed.", actLog);
      return false;
    }


  }//class
}//ns
