﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Vita.Entities.Authorization;

namespace Vita.Entities.Runtime {

  // Default base class for entity classes
  [Serializable]
  public abstract class EntityBase : INotifyPropertyChanged {
    public EntityRecord Record;

    //Constructor used by deserializers and linq
    public EntityBase() {
      Record = new EntityRecord(this);
    }
    
    public EntityBase(EntityRecord record) {
      Record = record;
    }

    public override string ToString() {
      return Record.ToString(); 
    }

    public override int GetHashCode() {
      return Record.GetHashCode(); //return PrimaryKey.GetHashCode()
    }

    #region INotifyPropertyChanged Members
    event PropertyChangedEventHandler INotifyPropertyChanged.PropertyChanged {
      add { Record.PropertyChanged += value; }
      remove {  Record.PropertyChanged -= value; }
    }
    #endregion


  }//class


}

