﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Text;

namespace Vita.Entities.Runtime {

  /// <summary> A container for paging parameters. </summary>
  public class Paging {
    public readonly int Skip;
    public readonly int Take;

    public Paging(int skip, int take) {
      Skip = skip;
      Take = take;
    }

    public bool IsNoPaging() {
      return Skip == 0 && Take == int.MaxValue;
    }

    public override string ToString() {
      return string.Format("skip={0},take={1}", Skip, Take);
    }
    //Static singletons
    public static readonly Paging NoPaging = new Paging(skip: 0, take: int.MaxValue);
    public static readonly Paging JustOne = new Paging(skip: 0, take: 1);
  }//class

} //ns
