﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Vita.Entities.Model;
using Vita.Entities.Authorization; 

namespace Vita.Entities {

  public enum EntityCommandKind {
    //Default CRUD types
    SelectAll,
    SelectAllPaged,
    SelectByKey,
    SelectByKeyManyToMany,
    Update,
    Insert,
    Delete,

    //Query-based custom commands
    CustomSelect,
    CustomUpdate,
    CustomInsert,
    CustomDelete,
    // Partial update
    PartialUpdate,
  }

  public interface IEntityCommand {
    string CommandName { get; }
    string Description { get; set; }
    EntityCommandKind Kind { get; }
    EntityArea Area { get; }
    //Selected entity for queries, updated/deleted/inserted entity for others
    Type TargetEntityType { get; }
  }

}
