﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Vita.Common;
using Vita.Entities.Model; 

namespace Vita.Entities {
  
  public class EntityArea {
    public EntityModel Model; 
    public string Name;
    public string SchemaName;
    //Same as SchemaName most of the time; used in EntityInfo.FullName - which is the name that appears in URLs for an entity. 
    // Might be set to null or value different from SchemaName
    public string EntityNamespace; 
    public string Description;

    // The constructor is internal, use EntityModelSetup.AddArea method 
    internal EntityArea(EntityModel model, string name, string schemaName, string description = null) {
      Model = model; 
      Name = name;
      SchemaName = schemaName.ToLowerInvariant();
      EntityNamespace = SchemaName;
      Description = description;
      Model.AreaList.Add(this); 
    }

    public override string ToString() {
      return Model + "/" + Name;
    }
    public override int GetHashCode() {
      return Name.GetHashCode();
    }
  }

}
