﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Vita.Entities;
using Vita.Entities.Runtime;
using Vita.Logging;

namespace Vita.Services {
  /// <summary>Provides an access to global application log. </summary>
  /// <remarks>This service is created by default, so it is always there; however, Log property might be null if there is global log.</remarks>
  public interface IAppLogService {
    Log Log { get; }
  }

  //implementation
  internal class AppLogService : IAppLogService, IEntityServiceInit {

    #region IAppLogService Members
    public Log Log { get; set; }
    #endregion

    #region IEntityServiceInit Members
    public void Init(IEntityStore entityStore) {

    }
    #endregion
  }

}
