﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Vita.Data;

namespace Vita.Services {

  //holds all registered data stores
  public interface IDataStoreListingService {
    void RegisterDataStore(IDataStore dataStore);
    IEnumerable<IDataStore> GetDataStores();
  }

  //implementation
  internal class DataStoreListingService : IDataStoreListingService {
    IList<IDataStore> _dataStores = new List<IDataStore>(); 

    #region IDataStoreListingService Members
    public void RegisterDataStore(IDataStore dataStore) {
      _dataStores.Add(dataStore);
    }

    public IEnumerable<IDataStore> GetDataStores() {
      return _dataStores; 
    }
    #endregion
  }
}
