﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Vita.Data.Caching {

  public enum CacheStatus {
    NonCurrent,
    Loading,
    Current,
  }

  /// <summary>An interface for monitoring and syncing cache. </summary>
  /// <remarks>The interface is implemented by CacheDataStore. It allows hooking an external cache synchronization module. </remarks>
  public interface ICacheControlService {
    bool CacheEnabled {get; set;}
    CacheStatus Status { get; }

    /// <summary>True if status is current and no items in update queue.</summary>
    bool Ready { get; }

    /// <summary> Invalidates cache content, does not start reloading </summary>
    void Invalidate(bool reload = false, bool waitForReloadComplete = false);

    CacheSettings GetSettings();
  }

}
