﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vita.Data.Caching;
using Vita.Entities;
using Vita.Entities.Runtime;

namespace Vita.Data {
  public partial class Database {

    /// <summary> Retrieves an underlying <c>Database</c> instance from an entity store. </summary>
    /// <param name="entityStore">An entity store.</param>
    /// <returns>Database object.</returns>
    public static Database GetDatabase(IEntityStore entityStore) {
      var entStore = (EntityStore)entityStore;
      var db = entStore.DataStore as Database;
      if (db != null) return db;
      var cache = entStore.DataStore as CacheDataStore;
      if (cache != null)
        db = cache.RealDataStore as Database;
      return db;
    }

  
  
  }//class
}
