﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Vita.Data.Driver {

  [Flags]
  public enum DbCapabilities {
    None = 0,

    Schemas = 1,
    ReferentialConstraints = 1 << 1,
    Paging = 1 << 2,
    StoredProcedures = 1 << 3,
    OutputParameters = 1 << 4,
    DefaultParameterValues = 1 << 5,

    DeferredConstraintCheck = 1 << 8,
    BatchedUpdates = 1 << 9,
    ClusteredIndexes = 1 << 10,
    NoIndexOnForeignKeys = 1 << 11, // server does NOT automatically create index on foreign keys, so these should be created explicitly
    OrderedColumnsInIndexes = 1 << 12, //supports ordered columns in indexes
    ForceNullableMemo = 1 << 13, //Memo columns must be nullable (SQL CE)
    NoMemoInDistinct = 1 << 14, //Memo columns are not allowed in DISTINCT clause (SQL CE)

    //Custom SQLs
    CustomSelect = 1 << 16,
    CustomUpdate = 1 << 17,
    CustomInsert = 1 << 18,
    CustomDelete = 1 << 19,
    CustomAll = CustomSelect | CustomUpdate | CustomInsert | CustomDelete,
  }

}
