﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Vita.Data.Linq {

  public static class LinqTypeUtility {

    public static bool IsDbPrimitive(this Type type) {
      return type.IsPrimitive || type.IsEnum || type == typeof(string) || type == typeof(Guid) || type == typeof(DateTime) || type == typeof(Decimal);
    }
    
    public static bool IsSequenceOfDbPrimitive(this Type type) {
      var isGenSeq = type.IsGenericType && typeof(IEnumerable).IsAssignableFrom(type);
      if (!isGenSeq)
        return false;
      var elemType = type.GenericTypeArguments[0];
      return elemType.IsDbPrimitive();
    }


  }
}
