
using System; 
using System.Diagnostics;
using System.Linq.Expressions;
using System.Reflection;

using Vita.Data.Model;

namespace Vita.Data.Linq.Translation.Expressions
{
    /// <summary>
    /// Describes a column, related to a table
    /// </summary>
    [DebuggerDisplay("ColumnExpression {Table.Name} (as {Table.Alias}).{Name}")]
    public class ColumnExpression : MutableExpression
    {
        public const ExpressionType ExpressionType = (ExpressionType)CustomExpressionType.Column;

        public TableExpression Table { get; private set; }
        public string Name { get; private set; }
        public MemberInfo MemberInfo { get; private set; }
        public DbColumnInfo ColumnInfo; 
        public string Alias { get; set; }


        public ColumnExpression(TableExpression table, DbColumnInfo columnInfo) : base(ExpressionType, GetMemberType(columnInfo)) {
            Table = table;
            ColumnInfo = columnInfo; 
            Name = ColumnInfo.ColumnName;
            MemberInfo = ColumnInfo.Member.ClassProperty;
        }
      //RI: bit/bool
        private static Type GetMemberType(DbColumnInfo columnInfo) {
     /*     if (columnInfo.Member.DataType == typeof(bool) && columnInfo.TypeInfo.SqlTypeSpec.ToLower() == "bit") {
            return typeof(int);
          } */
          return columnInfo.Member.DataType; 
        }
 
    }
}