
using System;
using System.Diagnostics;
using System.Linq.Expressions;
using System.Reflection;

namespace Vita.Data.Linq.Translation.Expressions {

    public enum ExternalValueSqlUse {
      NotUsed = 0,
      Parameter = 1,
      Literal = 2,

    }

    /// <summary>Represents external value - query parameter or value derived from it.</summary>
    public class ExternalValueExpression : MutableExpression
    {
        public Expression SourceExpression;
        public const ExpressionType ExpressionType = (ExpressionType)CustomExpressionType.InputParameter;
        // Counts # of times the value is used in expression directly, and not as an object for member access (ex: 'prm.SomeProp' with prm being an object)
        // Only parameters with FreeUseCount > 0 are real dbParameters
        public int FreeUseCount;

        public ExternalValueSqlUse SqlUse; 

        public SqlQueryParameter SqlParameter; // asigned only for real db parameters
        public object LiteralValue; // if Usage==Literal

        //public string Alias { get; set; }

        public ExternalValueExpression(Expression sourceExpression)   : base(ExpressionType, sourceExpression.Type) {
          SourceExpression = sourceExpression;
          SqlUse = ExternalValueSqlUse.NotUsed; //default
        }

        public override string ToString() {
          return "P:" + SourceExpression.ToString();
        }
    }
    
}