
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq.Expressions;

namespace Vita.Data.Linq.Translation.Expressions
{
    public abstract class OperandsMutableExpression : MutableExpression
    {
        protected OperandsMutableExpression(ExpressionType expressionType, Type type, IList<Expression> operands)
            : base(expressionType, type)
        {
            if(operands==null)
                operands = new Expression[0];
            this.OperandsCollection = new ReadOnlyCollection<Expression>(operands);
        }

        protected ReadOnlyCollection<Expression> OperandsCollection;
        public override IEnumerable<Expression> Operands
        {
            get { return OperandsCollection; }
        }

        /// <summary>
        /// Must be implemented by inheritors. I had no better name. Suggestions welcome
        /// </summary>
        /// <param name="operands"></param>
        /// <returns></returns>
        protected abstract Expression Mutate2(IList<Expression> operands);

        public override Expression Mutate(IList<Expression> newOperands)
        {
            return Mutate2(newOperands);
        }
    }
}