
using System.Linq.Expressions;

namespace Vita.Data.Linq.Translation.Expressions
{
    /// <summary>
    /// Represents a ORDER column to be sorted on
    /// </summary>
    public class OrderByExpression : MutableExpression
    {
        public const ExpressionType ExpressionType = (ExpressionType)CustomExpressionType.OrderBy;

        public bool Descending { get; set; }
        public Expression ColumnExpression { get; set; }

        public OrderByExpression(bool descending, Expression columnExpression)
            : base(ExpressionType, null)
        {
            Descending = descending;
            ColumnExpression = columnExpression;
        }

        public override Expression Mutate(System.Collections.Generic.IList<Expression> newOperands)
        {
            ColumnExpression = newOperands[0];
            return this;
        }

        public override System.Collections.Generic.IEnumerable<Expression> Operands
        {
            get
            {
                yield return ColumnExpression;
            }
        }
    }
}