
namespace Vita.Data.Linq.Translation.Expressions
{
    /// <summary>
    /// SQL specific (and DBlinq required) custom expression types.
    /// To add a new value here, please be sure to handle it everywhere
    /// For this, search for "// SETuse" comment in project
    /// </summary>
    public enum SpecialExpressionType
    {
        IsNull = 100,
        IsNotNull,
        Concat,
        Count,
        Exists,
        Like,
        Min,
        Max,
        Sum,
        Average,
        StringLength,
        ToUpper,
        ToLower,
        In,
        Substring,
        Trim,
        LTrim,
        RTrim,

        StringInsert,
        Replace,
        Remove,
        IndexOf,

        Year,
        Month,
        Day,
        Hour,
        Minute,
        Second,
        Millisecond,
        Now,
        Date,
        DateDiffInMilliseconds,

        Abs,
        Exp,
        Floor,
        Ln,
        Log,
        Pow,
        Round,
        Sign,
        Sqrt, 

        //RI: 
        AndBitwise,
        OrBitwise,
        XorBitwise,
    }
}