
using System;
using System.Collections.Generic;
using System.Linq.Expressions;

using Vita.Common;

namespace Vita.Data.Linq.Translation.Expressions
{
    public abstract class MutableExpression : Expression, IMutableExpression
    {
      public override ExpressionType NodeType {
        get { return _nodeType;  }
      }  ExpressionType _nodeType;
      public override Type Type {
        get { return _type; }
      }
      Type _type; 
        protected MutableExpression(ExpressionType nodeType, Type type)
            : base()
        {
          _nodeType = nodeType;
          _type = type; 
        }

        public virtual IEnumerable<Expression> Operands
        {
            get { return new Expression[0]; }
        }

        public virtual Expression Mutate(IList<Expression> newOperands)
        {
            if (newOperands.Count > 0)
                Util.Throw("S0047: Default MutableExpression does not allow operands");
            return this;
        }
    }
}