﻿
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Vita.Data.Linq.Translation {

    internal class LineGrouping<K, T> : IGrouping<K, T>
    {
        protected T Line { get; private set; }

        public LineGrouping(K key, T line)
        {
            this.key = key;
            Line = line;
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return ((IEnumerable<T>)this).GetEnumerator();
        }

        public IEnumerator<T> GetEnumerator()
        {
            yield return Line;
        }

        private readonly K key;
        public K Key
        {
            get { return key; }
        }
    }
}