﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Vita.Entities;
using Vita.Entities.Authorization;
using Vita.Entities.Runtime;
using Vita.Modules.ErrorLogging;

namespace Vita.Samples.BooksModel {
  public class BooksEntityModel : EntityModel {
    public BooksModule MainModule; 
    public IAuthorizationService Authorization;
    // ErrorLog is available as service (EntityStore.GetService<IErrorLogService>()))
    public ErrorLogModule ErrorLogModule;

    public BooksEntityModel() {
      var booksArea = this.AddArea("Books", "books");
      MainModule = new BooksModule(booksArea);
      var logArea = this.AddArea("Log", "log");
      ErrorLogModule = new ErrorLogModule(logArea);
      Authorization = new AuthorizationService(this);
    }

  }//class
}//ns
