﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Vita.Tutorial {
  class Program {
    static void Main(string[] args) {
      Console.WriteLine("VITA Tutorial Samples. ");
      Console.WriteLine("This application contains sample code for online tutorial for VITA framework.");
      Console.WriteLine("See http://vita.codeplex.com");
      Console.WriteLine("The application uses a local database VitaTutorial.");
      Console.WriteLine();
      Console.WriteLine("Press any key to continue...");
      Console.ReadKey(); 
      
        try {
          Setup.Init(); 
          RunSamples();
        } catch (Exception ex) {
          Console.ForegroundColor = ConsoleColor.Red;
          Console.WriteLine("Exception: " + ex.ToString());
          Console.ForegroundColor = ConsoleColor.White;
          Console.WriteLine("Press any key to exit.");
          Console.ReadKey();
        }
    }//method

    private static void RunSamples() {
      while (true) {
        Console.Clear();
        Console.WriteLine("Enter a sample# to execute:");
        Console.WriteLine();
        Console.WriteLine("  1 - Basics: entities, models, setup, CRUD and LINQ over entities.");
        Console.WriteLine("  2 - Attributes, relations, entity lists, paging, computed properties.");
        Console.WriteLine("  3 - Database keys, indexes, special SQL types.");
        Console.WriteLine("  4 - Entity validation, non-fatal exceptions.");
        // Temporarily disabled
     //   Console.WriteLine("  5 - Custom stored procedures.");
        Console.WriteLine("  0 or empty - exit.");
        Console.WriteLine();
        Console.Write("#:");
        var resp = Console.ReadLine();
        if (string.IsNullOrWhiteSpace(resp) || resp == "0") 
          return;
        switch (resp.Trim()) {
          case "1":
            Vita.Tutorial.Part1.Part1_Sample.RunSample();
            break;
          case "2":
            Vita.Tutorial.Part2.Part2_Sample.RunSample();
            break;
          case "3":
            Vita.Tutorial.Part3.Part3_Sample.RunSample();
            break;
          case "4":
            Vita.Tutorial.Part4.Part4_Sample.RunSample();
            break;
      /*    case "5":
            Vita.Tutorial.Part5.Part5_Sample.RunSample();
            break; */
          default:
            Console.WriteLine("Unrecognized input.");
            break;
        }
        Console.Write("Press any key to continue...");
        Console.ReadKey();
      }//while

    }

  }
}
