﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration; 

using Vita.Entities;
using Vita.Data;
using Vita.Data.Driver; 

namespace Vita.Tutorial {

  public static class Setup {
    public static string ConnectionString;
    public static DbDriver DbDriver;
    public static DbSchemaManager SchemaManager;

    public static void Init() {
      ConnectionString = ConfigurationManager.AppSettings["MsSqlConnectionString"];
      DbDriver = new Vita.Data.MsSql.MsSqlDriver(); 
      SchemaManager = Setup.DbDriver.CreateSchemaManager(ConnectionString);
      // check connection
      try {
        var conn = new System.Data.SqlClient.SqlConnection(ConnectionString);
        conn.Open();
        conn.Close();
      } catch (Exception ex) {
        throw new Exception("Failed to connect to VitaTutorial local database. Create database and restart the application. \r\n\r\n" +
        "Original Error: " + ex.Message + "\r\n");
      }
    }

  }
}
